package com.mamezou.scope;

import java.io.IOException;

import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.context.ApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

public class ScopedExampleServlet extends HttpServlet {

    private static final long serialVersionUID = 1353908471070297334L;

    private transient ServletContext servletContext;

    @Override
    public void init(ServletConfig servletConfig) throws ServletException {
        super.init(servletConfig);
        servletContext = servletConfig.getServletContext();
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse res)
            throws ServletException, IOException {
        req.setAttribute("scopedBean", getScopedExampleBean());
        req.getRequestDispatcher("WEB-INF/jsp/ScopedExample.jsp").forward(req, res);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse res)
            throws ServletException, IOException {
        doGet(req, res);
    }

    private ScopedBean getScopedExampleBean() {
        ApplicationContext context = WebApplicationContextUtils
                .getRequiredWebApplicationContext(servletContext);
        return (ScopedBean) context.getBean("scopedBean");
    }
}
